diff --git a/java/code/src/com/suse/manager/reactor/messaging/test/JobReturnEventMessageActionTest.java b/java/code/src/com/suse/manager/reactor/messaging/test/JobReturnEventMessageActionTest.java
index 3aebfc0eb3b..bfcb700da6f 100644
--- a/java/code/src/com/suse/manager/reactor/messaging/test/JobReturnEventMessageActionTest.java
+++ b/java/code/src/com/suse/manager/reactor/messaging/test/JobReturnEventMessageActionTest.java
@@ -1934,7 +1939,7 @@ public void testKiwiImageInspectCompressedImage() throws Exception {
                         (Map<String, Map<String, Map<String, Object>>>) map.get("images");
             assertEquals("https://ftp/saltboot/image/POS_Image_JeOS6.x86_64-6.0.0-1/POS_Image_JeOS6.x86_64-6.0.0",
                         images.get("POS_Image_JeOS6").get("6.0.0-1").get("url"));
-            assertEquals(Long.valueOf(1490026496), images.get("POS_Image_JeOS6").get("6.0.0-1").get("size"));
+            assertEquals(1490026496L, images.get("POS_Image_JeOS6").get("6.0.0-1").get("size"));
             assertEquals("a64dbc025c748bde968b888db6b7b9e3",
                         images.get("POS_Image_JeOS6").get("6.0.0-1").get("hash"));
             assertEquals("gzip", images.get("POS_Image_JeOS6").get("6.0.0-1").get("compressed"));
@@ -2145,7 +2150,7 @@ public void testSubscribeChannelsActionNullTokens() throws Exception {
         Map<LocalCall<?>, List<MinionSummary>> calls = saltServerActionService.callsForAction(action);
 
         // artifically expire tokens
-        action.getDetails().getAccessTokens().stream().forEach(t -> t.setMinion(null));
+        action.getDetails().getAccessTokens().forEach(t -> t.setMinion(null));
         HibernateFactory.getSession().flush();
 
         // Setup an event message from file contents
@@ -2163,8 +2168,8 @@ public void testSubscribeChannelsActionNullTokens() throws Exception {
 
     private void assertTokenChannel(MinionServer minion, Channel channel) {
         assertTrue(minion.getAccessTokens().stream()
-                .filter(token -> token.getChannels().size() == 1 && token.getChannels().contains(channel))
-                .findFirst().isPresent(), channel.getLabel());
+                .anyMatch(token -> token.getChannels().size() == 1 && token.getChannels().contains(channel)),
+                channel.getLabel());
     }
 
     @Test
@@ -2228,9 +2233,9 @@ public void testStateErrorResponse() throws Exception {
         messageAction.execute(message);
 
         // Verify the action status
-        assertTrue(action.getServerActions().stream()
+        assertEquals(ActionFactory.STATUS_FAILED, action.getServerActions().stream()
                 .filter(serverAction -> serverAction.getServer().equals(minion))
-                .findAny().get().getStatus().equals(ActionFactory.STATUS_FAILED));
+                .findAny().get().getStatus());
 
         // Verify the action message
         assertTrue(action.getServerActions().stream()
@@ -2254,14 +2259,14 @@ public void testActionChainResponse() throws Exception {
         Date earliestAction = new Date();
         ApplyStatesAction applyHighstate = ActionManager.scheduleApplyStates(
                 user,
-                Arrays.asList(minion.getId()),
+                Collections.singletonList(minion.getId()),
                 new ArrayList<>(),
                 earliestAction);
 
         ScriptActionDetails sad = ActionFactory.createScriptActionDetails(
                 "root", "root", 10L, "#!/bin/csh\necho hello");
         ScriptRunAction runScript = ActionManager.scheduleScriptRun(
-                user, Arrays.asList(minion.getId()), "Run script test", sad, earliestAction);
+                user, Collections.singletonList(minion.getId()), "Run script test", sad, earliestAction);
 
         ServerAction saHighstate = ActionFactoryTest.createServerAction(minion, applyHighstate);
         applyHighstate.addServerAction(saHighstate);
@@ -2321,8 +2326,8 @@ public void testActionChainPackageRefreshNeeded() throws Exception {
         MinionServer minion = MinionServerFactoryTest.createTestMinionServer(user);
         SystemManager.giveCapability(minion.getId(), SystemManager.CAP_SCRIPT_RUN, 1L);
 
-        ApplyStatesAction applyHighstate = ActionManager.scheduleApplyStates(user, Arrays.asList(minion.getId()),
-                new ArrayList<>(), new Date());
+        ApplyStatesAction applyHighstate = ActionManager.scheduleApplyStates(user,
+                Collections.singletonList(minion.getId()), new ArrayList<>(), new Date());
 
         ServerAction saHighstate = ActionFactoryTest.createServerAction(minion, applyHighstate);
         applyHighstate.addServerAction(saHighstate);
@@ -2358,8 +2363,8 @@ public void testActionChainPackageRefreshNotNeeded() throws Exception {
         MinionServer minion = MinionServerFactoryTest.createTestMinionServer(user);
         SystemManager.giveCapability(minion.getId(), SystemManager.CAP_SCRIPT_RUN, 1L);
 
-        ApplyStatesAction applyHighstate = ActionManager.scheduleApplyStates(user, Arrays.asList(minion.getId()),
-                new ArrayList<>(), new Date());
+        ApplyStatesAction applyHighstate = ActionManager.scheduleApplyStates(user,
+                Collections.singletonList(minion.getId()), new ArrayList<>(), new Date());
 
         ServerAction saHighstate = ActionFactoryTest.createServerAction(minion, applyHighstate);
         applyHighstate.addServerAction(saHighstate);
diff --git a/java/code/src/com/suse/manager/reactor/test/RegisterMinionActionTest.java b/java/code/src/com/suse/manager/reactor/test/RegisterMinionActionTest.java
index 35139e116d6..7fbb4522b60 100644
--- a/java/code/src/com/suse/manager/reactor/test/RegisterMinionActionTest.java
+++ b/java/code/src/com/suse/manager/reactor/test/RegisterMinionActionTest.java
@@ -1931,7 +1931,10 @@ public boolean isPaygInstance() {
                     will(returnValue(Optional.of(pil)));
                 }},
                 ACTIVATION_KEY_SUPPLIER,
-                (optMinion, machineId, key) -> assertTrue(optMinion.isPresent()),
+                (optMinion, machineId, key) -> {
+                    assertTrue(optMinion.isPresent());
+                    assertFalse(optMinion.get().isPayg(), "Unexpected: instance is PAYG");
+                },
                 DEFAULT_CONTACT_METHOD);
     }
 
@@ -1963,7 +1966,7 @@ public boolean isPaygInstance() {
                     allowing(saltServiceMock).getSystemInfoFull(MINION_ID);
                     will(returnValue(getSystemInfo(MINION_ID, null, key)));
                     allowing(saltServiceMock).getInstanceFlavor(MINION_ID);
-                    will(returnValue(SumaUtil.PublicCloudInstanceFlavor.PAYG));
+                    will(returnValue(SumaUtil.PublicCloudInstanceFlavor.BYOS));
                     List<ProductInfo> pil = new ArrayList<>();
                     ProductInfo pi = new ProductInfo(
                             product.getName(),
@@ -1976,7 +1979,10 @@ public boolean isPaygInstance() {
                     will(returnValue(Optional.of(pil)));
                 }},
                 ACTIVATION_KEY_SUPPLIER,
-                (optMinion, machineId, key) -> assertTrue(optMinion.isPresent()),
+                (optMinion, machineId, key) -> {
+                    assertTrue(optMinion.isPresent());
+                    assertFalse(optMinion.get().isPayg(), "Unexpected: instance is PAYG");
+                },
                 DEFAULT_CONTACT_METHOD);
     }
 
@@ -2000,7 +2006,10 @@ public boolean isPaygInstance() {
                     will(returnValue(SumaUtil.PublicCloudInstanceFlavor.PAYG));
                 }},
                 ACTIVATION_KEY_SUPPLIER,
-                (optMinion, machineId, key) -> assertTrue(optMinion.isPresent()),
+                (optMinion, machineId, key) -> {
+                    assertTrue(optMinion.isPresent());
+                    assertTrue(optMinion.get().isPayg(), "Unexpected: instance is not PAYG");
+                },
                 DEFAULT_CONTACT_METHOD);
     }
 
diff --git a/java/code/src/com/suse/manager/utils/SaltUtils.java b/java/code/src/com/suse/manager/utils/SaltUtils.java
index f11f36eeb36..4aa6b5022b1 100644
--- a/java/code/src/com/suse/manager/utils/SaltUtils.java
+++ b/java/code/src/com/suse/manager/utils/SaltUtils.java
@@ -1748,7 +1748,7 @@ private static void handleHardwareProfileUpdate(MinionServer server,
                     result.getCustomFqdns().stream()
                 ).distinct().collect(Collectors.toList())
         );
-        hwMapper.mapPaygInfo();
+        server.setPayg(result.getInstanceFlavor().map(o -> o.equals("PAYG")).orElse(false));
 
         // Let the action fail in case there is error messages
         if (!hwMapper.getErrors().isEmpty()) {
diff --git a/java/code/src/com/suse/manager/webui/utils/salt/custom/HwProfileUpdateSlsResult.java b/java/code/src/com/suse/manager/webui/utils/salt/custom/HwProfileUpdateSlsResult.java
index fcc859ed1fa..b34954a6a58 100644
--- a/java/code/src/com/suse/manager/webui/utils/salt/custom/HwProfileUpdateSlsResult.java
+++ b/java/code/src/com/suse/manager/webui/utils/salt/custom/HwProfileUpdateSlsResult.java
@@ -56,6 +56,9 @@ public class HwProfileUpdateSlsResult {
     @SerializedName("mgrcompat_|-network-modules_|-sumautil.get_net_modules_|-module_run")
     private StateApplyResult<Ret<Map<String, Optional<String>>>> networkModules;
 
+    @SerializedName("mgrcompat_|-instance-flavor_|-sumautil.instance_flavor_|-module_run")
+    private StateApplyResult<Ret<Optional<String>>> instanceFlavor;
+
     @SerializedName("mgrcompat_|-dns_fqdns_|-mgrnet.dns_fqdns_|-module_run")
     private Optional<StateApplyResult<Optional<Ret<Map<String, List<String>>>>>> fqdnsFromMgrNetModule =
             Optional.empty();
@@ -149,6 +152,16 @@ public Map<String, Optional<String>> getNetworkModules() {
         return networkModules.getChanges().getRet();
     }
 
+    /**
+     * @return the flavor of the instance
+     */
+    public Optional<String> getInstanceFlavor() {
+        if (instanceFlavor == null) {
+            return Optional.empty();
+        }
+        return instanceFlavor.getChanges().getRet();
+    }
+
     /**
      * @return smbios records of type: BIOS
      */
